<!doctype html>
<html>
<head>
  <link rel="stylesheet" href="file:///android_asset/style.css" />
</head>
<body>
  <h2>Kotlin Language</h2>
  The <i>Kotlin</i> language is introduced with these followings points :
  <ul>
    <li>Officially in Android</li>
    <li>Why Kotlin?</li>
    <li>History of Kotlin</li>
    <li>Kotlin Concept</li>
  </ul>

<h3>Officially in Android</h3>
<p>Google announced <i>Kotlin</i> as an official language in <i>Android</i> development,
on 19 may 2017 (G I/O 17-19 may 2017).</p>

<h3>Why Kotlin?</h3>
<p>Maybe because of <i>Oracle</i>.</p>

<h3>History of Kotlin</h3>
<p>To resume th history of <i>Kotlin</i>:
<table>
   <tr>
      <th>Date</th>
      <th>Version</th>
      <th>Note</th>
   </tr>
   <tr>
      <td>2010</td>
      <td>α</td>
      <td>Project start</td>
   </tr>
   <tr>
      <td>2011</td>
      <td>β</td>
      <td>Project unveil</td>
   </tr>
   <tr>
      <td>February 2012</td>
      <td>v 0</td>
      <td>Open source</td>
   </tr>
   <tr>
      <td>February 2016</td>
      <td>v 1.0</td>
      <td>First stable version</td>
   </tr>
   <tr>
      <td>May 2017</td>
      <td>v 1.0</td>
      <td>Support in Android</td>
   </tr>
   <tr>
      <td>November 2017</td>
      <td>v 1.2</td>
      <td>Sharing code between <i>JVM</i> and <i>Javascript</i> platform</td>
   </tr>
   <tr>
      <td>October 2018</td>
      <td>v 1.3</td>
      <td> Bringing of <i>coroutines</i> for asynchronous programming</td>
   </tr>
 </table>
 </p>

<h3>Kotlin Concept</h3>

<p>To resume, most important things in <i>Kotlin</i> are:
<ul>
 <li>direct language (no <code>;</code>)</li>
 <li>language clear and concise (no <code>getter/setter</code>)</li>
 <li>no <code>NullPointerException</code></li>
 <li>interpollation of string : <code>Log.i(TAG, "my width is $mWidth")</code></li>
 <li>simple declaration (<code>val</code> or <code>var</code>)</li>
 <li>implicite conversion : <code>val mWidth = 0</code></li>
</ul>
</p>

<h4>Next part</h4>
<a href="file:///android_asset/2A-kotlinclass.html">Class</a>
